ps.options(horizontal=FALSE,onefile=FALSE)
ps.options(pagecentre=TRUE)
ps.options(paper="letter")
ps.options(width=7.0,height=10.0)

condcorr  <- matrix(scan("condcorr.dat"),ncol=5,byrow=T)

y1970 <- condcorr[(condcorr[,1]==197),]
x1970 <- 1970 + 10*seq(1:dim(y1970)[1])/dim(y1970)[1]

y1980 <- condcorr[(condcorr[,1]==198),]
x1980 <- 1980 + 10*seq(1:dim(y1980)[1])/dim(y1980)[1]

y1990 <- condcorr[(condcorr[,1]==199),]
x1990 <- 1990 + 10*seq(1:dim(y1990)[1])/dim(y1990)[1]

y2000 <- condcorr[(condcorr[,1]==200),]
x2000 <- 2000 + 10*seq(1:dim(y2000)[1])/dim(y2000)[1]

postscript(file="condcorr.eps")
par(mfrow=c(4,1))
plot(c(min(x1970),max(x1970)),c(min(condcorr[,5]),max(condcorr[,5])),
   main="Conditional Correlation in the 1970's",
   xlab="Day",ylab="Correlation", type="n")
   lines(x1970,y1970[,5],type="l",lty=1)
plot(c(min(x1980),max(x1980)),c(min(condcorr[,5]),max(condcorr[,5])),
   main="Conditional Correlation in the 1980's",
   xlab="Day",ylab="Correlation", type="n")
   lines(x1980,y1980[,5],type="l",lty=1)
plot(c(min(x1990),max(x1990)),c(min(condcorr[,5]),max(condcorr[,5])),
   main="Conditional Correlation in the 1990's",
   xlab="Day",ylab="Correlation", type="n")
   lines(x1990,y1990[,5],type="l",lty=1)
plot(c(min(x2000),max(x2000)),c(min(condcorr[,5]),max(condcorr[,5])),
   main="Conditional Correlation in the 2000's",
   xlab="Day",ylab="Correlation", type="n")
   lines(x2000,y2000[,5],type="l",lty=1)
dev.off()
