#include "libscl.h"
#include "simple.h"
using namespace scl; 
using namespace std;

int main(int argc, char** argp, char** envp)
{
  string msg = string("Error, ") + argp[0] + ", ";

  if (argc < 2) error(msg+"specify a filename on command line");

  ifstream is(argp[1]);
  if (!is) error(msg+"bad filename");

  realmat rm;

  REAL r; 

  while (is >> r) rm.push_back(r);

  stats s = simple(rm.begin(), rm.end());

  cout << '\n'
    << "  mean     = " << s.mean << '\n'
    << "  std dev  = " << s.sdev << '\n'
    << "  variance = " << s.var  << '\n'
    << "  skewness = " << s.skew << '\n'
    << "  kurtosis = " << s.kurt << '\n'
    << "  no.obs.  = " << s.nobs << '\n' ;
 
  vector<REAL> vc(rm.size());
  copy(rm.begin(), rm.end(), vc.begin()); 

  s = simple(vc.begin(),vc.end());

  cout << '\n'
    << "  mean     = " << s.mean << '\n'
    << "  std dev  = " << s.sdev << '\n'
    << "  variance = " << s.var  << '\n'
    << "  skewness = " << s.skew << '\n'
    << "  kurtosis = " << s.kurt << '\n'
    << "  no.obs.  = " << s.nobs << '\n' ;
 
  return 0;
}
